package com.jpattern.orm.cache;

import java.io.Serializable;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 
 * @author Francesco Cina'
 *
 * 24/set/2011
 */
public class SimpleCacheManager implements CacheManager, Serializable {

    private static final long serialVersionUID = 1L;
    private final Map<String, Cache> cachesMap = new ConcurrentHashMap<String, Cache>();

    @Override
    public Cache getCache(final String cacheName) {
        Cache cache = cachesMap.get(cacheName);
        if (cache == null) {
            cache = new SimpleCache();
            cachesMap.put(cacheName, cache);
        }
        return cache;
    }

    @Override
    public void stopCacheManager() {
        cachesMap.clear();
    }

}
