package com.jpattern.orm.dialect;

/**
 * 
 * @author ufo
 *
 */
public enum DBType {

    UNKNOWN(new UnknownDBProfile()),
    DERBY(new DerbyDBProfile()),
    H2(new H2DBProfile()),
    HSQLDB(new HSQLDB2DBProfile()),
    MYSQL(new MysqlDBProfile()),
    ORACLE(new Oracle10gDBProfile());

    private final DBProfile dbProfile;

    private DBType(final DBProfile dbProfile) {
        this.dbProfile = dbProfile;
    }

    public DBProfile getDBProfile() {
        return dbProfile;
    }

}
