/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 28, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.mapper;

import com.jpattern.orm.annotation.table.TableInfo;
import com.jpattern.orm.mapper.clazz.ClassMap;
import com.jpattern.orm.mapper.clazz.IClassMap;
import com.jpattern.orm.persistor.OrmPersistor;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 28, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class NullOrmClassTool<T> implements IOrmClassTool<T> {

    @Override
    public IClassMap<T> getClassMap() {
        return new ClassMap<T>(null, new TableInfo("", ""));  //$NON-NLS-1$//$NON-NLS-2$
    }

    @Override
    public OrmPersistor<T> getOrmPersistor() {
        return null;
    }

}
