package com.jpattern.orm.mapper;

import com.jpattern.orm.persistor.type.TypeFactory;


/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 */
public class NullOrmClassToolMap implements IOrmClassToolMap {

    @Override
    public <T> void put(final Class<T> clazz, final IOrmClassTool<T> ormClassTool) {
        // do nothing
    }

    @Override
    public boolean containsTool(final Class<?> clazz) {
        return false;
    }

    @SuppressWarnings({ "rawtypes", "unchecked" })
    @Override
    public <T> IOrmClassTool<T> getOrmClassTool(final Class<T> clazz) {
        return new NullOrmClassTool();
    }

    @Override
    public TypeFactory getTypeFactory() {
        return new TypeFactory();
    }

}
