package com.jpattern.orm.mapper;

import com.jpattern.orm.mapper.clazz.IClassMap;
import com.jpattern.orm.persistor.OrmPersistor;


/**
 * 
 * @author Francesco Cina
 *
 * 22/mag/2011
 */
public class OrmClassTool<BEAN> implements IOrmClassTool<BEAN> {

    private final IClassMap<BEAN> classMapper;
    private final OrmPersistor<BEAN> ormPersistor;

    public OrmClassTool(final IClassMap<BEAN> classMapper, final OrmPersistor<BEAN> ormPersistor) {
        this.classMapper = classMapper;
        this.ormPersistor = ormPersistor;
    }

    @Override
    public IClassMap<BEAN> getClassMap() {
        return this.classMapper;
    }

    @Override
    public OrmPersistor<BEAN> getOrmPersistor() {
        return this.ormPersistor;
    }

}
