package com.jpattern.orm.mapper.clazz;

import com.jpattern.orm.annotation.column.ColumnInfo;
import com.jpattern.orm.annotation.generator.GeneratorInfo;
import com.jpattern.orm.annotation.version.VersionInfo;
import com.jpattern.orm.persistor.reflection.GetManipulator;
import com.jpattern.orm.persistor.reflection.SetManipulator;


/**
 * 
 * @author cinafr
 *
 * @param <P>
 */
public class ClassField<BEAN, P> implements IClassField<BEAN, P> {

    private VersionInfo versionInfo;
    private GeneratorInfo generatorInfo;
    private GetManipulator<BEAN, P> getManipulator;
    private SetManipulator<BEAN, P> setManipulator;
    private ColumnInfo columnInfo;
    private final String fieldName;
    private final Class<P> type;
    private boolean identifier = false;
    private Class<?> relationVersusClass = null;

    public ClassField(final Class<P> type,  final String fieldName) {
        this.type = type;
        this.fieldName = fieldName;
    }

    @Override
    public VersionInfo getVersionInfo() {
        return this.versionInfo;
    }

    public void setVersionInfo(final VersionInfo versionInfo) {
        this.versionInfo = versionInfo;
    }

    @Override
    public GeneratorInfo getGeneratorInfo() {
        return this.generatorInfo;
    }

    public void setGeneratorInfo(final GeneratorInfo generatorInfo) {
        this.generatorInfo = generatorInfo;
    }

    @Override
    public final boolean isIdentifier()
    {
        return this.identifier ;
    }

    public final void setIdentifier(final boolean identifier) {
        this.identifier = identifier;
    }

    @Override
    public final Class<P> getType() {
        return this.type;
    }

    @Override
    public final GetManipulator<BEAN, P> getGetManipulator() {
        return this.getManipulator;
    }

    public final void setGetManipulator(final GetManipulator<BEAN, P> getManipulator) {
        this.getManipulator = getManipulator;
    }

    @Override
    public final SetManipulator<BEAN, P> getSetManipulator() {
        return this.setManipulator;
    }

    public final void setSetManipulator(final SetManipulator<BEAN, P> setManipulator) {
        this.setManipulator = setManipulator;
    }

    @Override
    public final ColumnInfo getColumnInfo() {
        return this.columnInfo;
    }

    public final void setColumnInfo(final ColumnInfo columnInfo) {
        this.columnInfo = columnInfo;
    }

    @Override
    public final String getFieldName() {
        return this.fieldName;
    }

    @SuppressWarnings("unchecked")
    @Override
    public <VERSUS_CLASS> Class<VERSUS_CLASS> getRelationVersusClass() {
        return (Class<VERSUS_CLASS>) relationVersusClass;
    }

    public void setRelationVersusClass(final Class<?> relationVersusClass) {
        this.relationVersusClass = relationVersusClass;
    }
}
