/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 18, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.mapper.relation;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 18, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class ForeignKeyImpl<VERSUS_CLASS> implements ForeignKey<VERSUS_CLASS> {

    private final Class<VERSUS_CLASS> versusClass;
    private final String beanFieldName;

    public ForeignKeyImpl(final String beanFieldName, final Class<VERSUS_CLASS> versusClass) {
        this.beanFieldName = beanFieldName;
        this.versusClass = versusClass;

    }

    @Override
    public Class<VERSUS_CLASS> getVersusClass() {
        return versusClass;
    }

    @Override
    public String getBeanFieldName() {
        return beanFieldName;
    }

}
