/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 13, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.mapper.relation;

import com.jpattern.orm.mapper.clazz.IClassField;
import com.jpattern.orm.persistor.reflection.GetManipulator;
import com.jpattern.orm.persistor.reflection.SetManipulator;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 13, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public interface RelationOuterFK<BEAN, P, MANIPULATOR> {

    Class<P> getRelationWithClass();

    /**
     * @return
     */
    IClassField<P, Object> getRelationClassField();


    String getJavaFieldName();

    /**
     * @return
     */
    GetManipulator<BEAN, MANIPULATOR> getGetManipulator();

    /**
     * @return
     */
    SetManipulator<BEAN, MANIPULATOR> getSetManipulator();

    void copyFromTo(BEAN source, BEAN destination);

    boolean isOneToMany();
}
