package com.jpattern.orm.persistor.generator;

import java.lang.reflect.InvocationTargetException;

/**
 * 
 * @author Francesco Cina'
 *
 * Apr 1, 2012
 */
public abstract class GeneratorManipulator<BEAN> {

    /**
     * 
     * Check if a generator has to be activated for a bean.
     * 
     * @param bean
     * @return
     * @throws IllegalArgumentException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     */
    public abstract boolean useGenerator(BEAN bean) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;

    /**
     * Return true if a bean has an active generator associated
     * @return
     */
    public abstract boolean hasGenerator();
}
