package com.jpattern.orm.persistor.reflection;

import java.lang.reflect.Field;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * Get the value of bean a using directly accessing it
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class FieldGetManipulator<BEAN, P> extends GetManipulator<BEAN, P> {

    private final Field field;

    public FieldGetManipulator(final Field field) {
        this.field = field;
        field.setAccessible(true);
    }

    @Override
    public P getValue(final BEAN bean) {
        try {
            return (P) this.field.get(bean);
        } catch (Exception e) {
            throw new OrmException(e);
        }
    }

}
