package com.jpattern.orm.persistor.reflection;

import java.lang.reflect.Method;

import com.jpattern.orm.exception.OrmException;

/**
 * 
 * Set the value of a using the related setter method
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class GetterGetManipulator<BEAN, P> extends GetManipulator<BEAN, P> {

    private final Method getterMethod;

    public GetterGetManipulator(final Method getterMethod) {
        this.getterMethod = getterMethod;
    }

    @Override
    public P getValue(final BEAN bean) {
        try {
            return (P) this.getterMethod.invoke(bean);
        } catch (Exception e) {
            throw new OrmException(e);
        }
    }

}
