package com.jpattern.orm.persistor.reflection;

import java.lang.reflect.Method;

import com.jpattern.orm.exception.OrmException;


/**
 * 
 * Get the value of a field using the related getter method
 * 
 * @author Francesco Cina'
 *
 * Mar 31, 2012
 */
public class SetterSetManipulator<BEAN, P> extends SetManipulator<BEAN, P> {

    private final Method setterMethod;

    public SetterSetManipulator(final Method setterMethod) {
        this.setterMethod = setterMethod;
    }

    @Override
    public void setValue(final BEAN bean, final P value) {
        try {
            this.setterMethod.invoke(bean, value);
        } catch (Exception e) {
            throw new OrmException(e);
        }
    }

}
