/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Mar 2, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.persistor.type;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 2, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class TypeWrapperJdbcReady<P, DB> implements TypeWrapper<P, DB> {

    private final TypeWrapper<P, DB> typeWrapper;
    private final JdbcIO<DB> jdbcIO;

    TypeWrapperJdbcReady(final TypeWrapper<P, DB> typeWrapper, final JdbcIO<DB> jdbcIO) {
        this.typeWrapper = typeWrapper;
        this.jdbcIO = jdbcIO;
    }

    /**
     * @return
     * @see com.jpattern.orm.persistor.type.TypeWrapper#jdbcType()
     */
    @Override
    public Class<DB> jdbcType() {
        return getTypeWrapper().jdbcType();
    }

    /**
     * @return
     * @see com.jpattern.orm.persistor.type.TypeWrapper#propertyType()
     */
    @Override
    public Class<P> propertyType() {
        return getTypeWrapper().propertyType();
    }

    /**
     * @param value
     * @return
     * @see com.jpattern.orm.persistor.type.TypeWrapper#wrap(java.lang.Object)
     */
    @Override
    public P wrap(final DB value) {
        return getTypeWrapper().wrap(value);
    }

    /**
     * @param value
     * @return
     * @see com.jpattern.orm.persistor.type.TypeWrapper#unWrap(java.lang.Object)
     */
    @Override
    public DB unWrap(final P value) {
        return getTypeWrapper().unWrap(value);
    }

    /**
     * @param source
     * @return
     * @see com.jpattern.orm.persistor.type.TypeWrapper#clone(java.lang.Object)
     */
    @Override
    public P clone(final P source) {
        return getTypeWrapper().clone(source);
    }

    public JdbcIO<DB> getJdbcIO() {
        return jdbcIO;
    }

    public TypeWrapper<P, DB> getTypeWrapper() {
        return typeWrapper;
    }

}
