package com.jpattern.orm.query.clause.where;

import java.util.Collection;
import java.util.List;

import com.jpattern.orm.query.NameSolver;
import com.jpattern.orm.query.SmartRenderableSqlSubElement;

/**
 * 
 * @author Francesco Cina
 *
 * 19/giu/2011
 */
//TODO to refactor!!
public abstract class AExpressionElement extends SmartRenderableSqlSubElement implements ExpressionElement {

    private String property;
    private boolean singleValue;
    private Object value;
    private boolean multipleValues;
    private Collection<?> expressionValues;


    private PropertyDecorator propertyDecorator = new NullPropertyDecorator();
    private PropertyDecorator valueDecorator = new NullPropertyDecorator();
    private int elementStatusVersion;

    public final boolean hasValue() {
        return (singleValue);
    }

    public final boolean hasValues() {
        return (multipleValues && (expressionValues!=null) && (expressionValues.size()>0));
    }

    public Object getValue() {
        return value;
    }

    public void setValue(final Object value) {
        elementStatusVersion++;
        singleValue = true;
        multipleValues = false;
        this.value = value;
    }

    public Collection<?> getValues() {
        return expressionValues;
    }

    public void setValues(final Collection<?> values) {
        elementStatusVersion++;
        singleValue = false;
        multipleValues = true;
        expressionValues = values;
    }

    public final String getProperty() {
        return property;
    }

    public void setProperty(final String property) {
        elementStatusVersion++;
        this.property = property;
    }

    protected PropertyDecorator getPropertyDecorator() {
        return propertyDecorator;
    }

    protected void setPropertyDecorator(final PropertyDecorator propertyDecorator) {
        elementStatusVersion++;
        this.propertyDecorator = propertyDecorator;
    }

    protected PropertyDecorator getValueDecorator() {
        return valueDecorator;
    }

    protected void setValueDecorator(final PropertyDecorator valueDecorator) {
        elementStatusVersion++;
        this.valueDecorator = valueDecorator;
    }

    @Override
    public final void doElementRender(final StringBuilder query, final NameSolver nameSolver) {
        query.append( getPropertyDecorator().decore( nameSolver.solvePropertyName(getProperty()) ) );
        query.append( " " ); //$NON-NLS-1$
        query.append( getExpressionElementKey() );
        query.append( " " ); //$NON-NLS-1$
        appendQuestionMarks(query);
    }

    private void appendQuestionMarks(final StringBuilder query) {
        if (hasValue()) {
            query.append( getValueDecorator().decore("?") + " " ); //$NON-NLS-1$ //$NON-NLS-2$
            return;
        }
        if (hasValues()) {
            query.append( "( "); //$NON-NLS-1$
            for (int i=0; i<(getValues().size()-1); i++) {
                query.append( getValueDecorator().decore("?") + ", " ); //$NON-NLS-1$ //$NON-NLS-2$
            }
            query.append( getValueDecorator().decore("?") + " ) "); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    public abstract String getExpressionElementKey();

    @Override
    public final void appendElementValues(final List<Object> values) {
        if (hasValue()) {
            values.add(value);
        }
        if (hasValues()) {
            values.addAll( expressionValues );
        }
    }

    @Override
    public final int getElementStatusVersion() {
        return elementStatusVersion;
    }
}
