package com.jpattern.orm.query.clause.where;

import java.util.List;

import com.jpattern.orm.query.NameSolver;
import com.jpattern.orm.query.SmartRenderableSqlSubElement;

/**
 * 
 * @author Francesco Cina
 *
 * 26/giu/2011
 */
public abstract class MultipleExpressionElement extends SmartRenderableSqlSubElement implements ExpressionElement {

    private final String relationType;
    private final List<ExpressionElement> expressionElements;

    public MultipleExpressionElement(final String relationType, final List<ExpressionElement> expressionElements) {
        this.expressionElements = expressionElements;
        this.relationType = relationType;
    }

    @Override
    public final void doElementRender(final StringBuilder stringBuilder, final NameSolver nameSolver) {
        stringBuilder.append("( "); //$NON-NLS-1$
        int last = expressionElements.size() - 1;
        if (last<0) {
            stringBuilder.append( "1=1 " ); //$NON-NLS-1$
        } else {
            for (int i=0; i<expressionElements.size(); i++) {
                expressionElements.get(i).renderSqlElement(stringBuilder, nameSolver);
                if (i!=last) {
                    stringBuilder.append(relationType);
                }
            }
        }
        stringBuilder.append(") "); //$NON-NLS-1$
    }

    @Override
    public final void appendElementValues(final List<Object> values) {
        for (ExpressionElement expressionElement : expressionElements) {
            expressionElement.appendElementValues(values);
        }
    }

    @Override
    public final int getElementStatusVersion() {
        return 0;
    }

}