package com.jpattern.orm.query.delete;

import java.util.List;

import com.jpattern.orm.query.clause.OrmWhere;

/**
 * 
 * @author ufo
 *
 */
public class DeleteWhereImpl<BEAN> extends OrmWhere<DeleteWhere<BEAN>> implements DeleteWhere<BEAN> {

    private final DeleteQuery<BEAN> deleteQuery;

    public DeleteWhereImpl(final DeleteQuery<BEAN> deleteQuery) {
        this.deleteQuery = deleteQuery;
    }

    @Override
    public String renderSql() {
        return this.deleteQuery.renderSql();
    }

    @Override
    public void renderSql(final StringBuilder stringBuilder) {
        this.deleteQuery.renderSql(stringBuilder);
    }

    @Override
    public void appendValues(final List<Object> values) {
        this.deleteQuery.appendValues(values);
    }

    @Override
    public DeleteQuery<BEAN> query() {
        return this.deleteQuery;
    }

    @Override
    protected DeleteWhere<BEAN> where() {
        return this;
    }

    @Override
    public int now() {
        return this.deleteQuery.now();
    }

    @Override
    public DeleteQuery<BEAN> queryTimeout(final int queryTimeout) {
        return this.deleteQuery.queryTimeout(queryTimeout);
    }

}
