package com.jpattern.orm.query.find;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.mapper.IOrmClassToolMap;
import com.jpattern.orm.query.NameSolver;
import com.jpattern.orm.query.clause.OrmFrom;

/**
 * 
 * @author ufo
 *
 */
public class CustomFindFromImpl extends OrmFrom<CustomFindQuery> implements CustomFindFrom {

    private final CustomFindQuery customFindQuery;

    public CustomFindFromImpl(final CustomFindQuery customFindQuery, final IOrmClassToolMap ormClassToolMap, final Class<?> clazz, final Integer nameSolverClassId, final NameSolver nameSolver)  {
        super(ormClassToolMap, clazz, nameSolverClassId, nameSolver);
        this.customFindQuery = customFindQuery;
    }

    @Override
    protected CustomFindQuery from() throws OrmException {
        return customFindQuery;
    }

}
