package com.jpattern.orm.query.find;

import java.math.BigDecimal;
import java.util.List;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.exception.OrmNotUniqueResultException;
import com.jpattern.orm.query.LockMode;
import com.jpattern.orm.query.clause.OrmOrderBy;
import com.jpattern.orm.session.ResultSetReader;
import com.jpattern.orm.session.ResultSetRowReader;

/**
 * 
 * @author ufo
 *
 */
public class CustomFindOrderByImpl extends OrmOrderBy<CustomFindOrderBy> implements CustomFindOrderBy {

    private final CustomFindQuery customFindQuery;

    @Override
    public String renderSql() {
        return customFindQuery.renderSql();
    }

    @Override
    public void renderSql(final StringBuilder stringBuilder) {
        customFindQuery.renderSql(stringBuilder);
    }

    @Override
    public void appendValues(final List<Object> values) {
        customFindQuery.appendValues(values);
    }

    public CustomFindOrderByImpl(final CustomFindQuery customFindQuery) {
        this.customFindQuery = customFindQuery;
    }

    @Override
    public CustomFindQuery query() {
        return customFindQuery;
    }

    @Override
    public CustomFindWhere where() throws OrmException {
        return customFindQuery.where();
    }

    @Override
    public <T> T get(final ResultSetReader<T> rse) throws OrmException {
        return customFindQuery.get(rse);
    }

    @Override
    protected CustomFindOrderBy orderBy() throws OrmException {
        return this;
    }

    @Override
    public List<Object[]> getList() throws OrmException {
        return customFindQuery.getList();
    }

    @Override
    public Object[] getUnique() throws OrmNotUniqueResultException {
        return customFindQuery.getUnique();
    }

    @Override
    public int getInt() throws OrmException {
        return customFindQuery.getInt();
    }

    @Override
    public long getLong() throws OrmException {
        return customFindQuery.getLong();
    }

    @Override
    public double getDouble() throws OrmException {
        return customFindQuery.getDouble();
    }

    @Override
    public float getFloat() throws OrmException {
        return customFindQuery.getFloat();
    }

    @Override
    public String getString() throws OrmException {
        return customFindQuery.getString();
    }

    @Override
    public boolean getBoolean() throws OrmException {
        return customFindQuery.getBoolean();
    }

    @Override
    public BigDecimal getBigDecimal() throws OrmException {
        return customFindQuery.getBigDecimal();
    }

    @Override
    public CustomFindQuery lockMode(final LockMode lockMode) {
        return customFindQuery.lockMode(lockMode);
    }

    @Override
    public CustomFindQuery maxRows(final int maxRows) throws OrmException {
        return customFindQuery.maxRows(maxRows);
    }

    @Override
    public CustomFindQuery queryTimeout(final int queryTimeout) {
        return customFindQuery.queryTimeout(queryTimeout);
    }

    @Override
    public CustomFindQuery distinct(final boolean distinct) throws OrmException {
        return customFindQuery.distinct(distinct);
    }

    @Override
    public <T> List<T> get(final ResultSetRowReader<T> rsrr) throws OrmException {
        return customFindQuery.get(rsrr);
    }

    @Override
    public <T> T getUnique(final ResultSetRowReader<T> rsrr) throws OrmException, OrmNotUniqueResultException {
        return customFindQuery.getUnique(rsrr);
    }

}
