package com.jpattern.orm.query.find;

import com.jpattern.orm.exception.OrmException;
import com.jpattern.orm.query.BaseFindQuery;
import com.jpattern.orm.query.CustomQuery;
import com.jpattern.orm.query.LockMode;

/**
 * 
 * @author Francesco Cina
 *
 * 07/lug/2011
 */
public interface CustomFindQueryCommon extends BaseFindQuery, CustomQuery {

    /**
     * Whether to use Distinct in the select clause
     * @return
     */
    CustomFindQuery distinct(boolean distinct) throws OrmException;

    /**
     * Set the {@link LockMode} for the query
     * @param lockMode
     * @return
     */
    CustomFindQuery lockMode(LockMode lockMode);

    /**
     * Set the maximum number of rows to return.
     * @param maxRows
     * @return
     */
    CustomFindQuery maxRows(int maxRows) throws OrmException;

    /**
     * Set the query timeout.
     */
    CustomFindQuery queryTimeout(int queryTimeout);

}
