/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Mar 5, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.query.find.cache;

import java.util.List;

import com.jpattern.orm.query.OrmRowMapper;

/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Mar 5, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class NullCacheStrategy<BEAN> implements CacheStrategy<BEAN> {

    private static final CacheStrategyEntry<Object> nullCallback = new CacheStrategyEntry<Object>() {
        @Override
        public void add(final Object bean) {
            //do nothing
        }

        @Override
        public void end() {
            //do nothing
        }
    };

    @SuppressWarnings("unchecked")
    @Override
    public void find(final String sql, final List<Object> values,
            final List<String> ignoredFields, final int maxRows, final OrmRowMapper<BEAN> srr,
            final CacheStrategyCallback<BEAN> cacheStrategyCallback) {
        cacheStrategyCallback.doWhenNotInCache((CacheStrategyEntry<BEAN>) nullCallback);

    }

}
