package com.jpattern.orm.query.save;

import com.jpattern.orm.dialect.DBProfile;

/**
 * 
 * @author Francesco Cina
 *
 * 05/giu/2011
 */
public abstract class AColumnValueGenerator  {

    private final String name;
    private String generatedColumnName = ""; //$NON-NLS-1$
    private final DBProfile dbProfile;

    public AColumnValueGenerator(final String name, final DBProfile dbProfile) {
        this.name = name;
        this.dbProfile = dbProfile;
    }

    public String getName() {
        return name;
    }

    public void setGeneratedColumnName(final String generatedColumnName) {
        this.generatedColumnName = generatedColumnName;
    }

    public String getGeneratedColumnName() {
        return generatedColumnName;
    }

    public abstract String insertQueryParameter(String currentValue);

    public abstract String insertColumn(String currentValue);

    public abstract boolean returnGeneratedKeys();

    public abstract boolean isAutoGenerated();

    protected final DBProfile getDbProfile() {
        return dbProfile;
    }

}
