/* ----------------------------------------------------------------------------
 *     PROJECT : JPOrm
 *
 *  CREATED BY : Francesco Cina'
 *          ON : Feb 23, 2013
 * ----------------------------------------------------------------------------
 */
package com.jpattern.orm.query.save.orm;


/**
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 23, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public interface SaveOrUpdate<BEAN> {

    /**
     * Perform the save or update
     * @return
     */
    BEAN now();

    /**
     * Whether to propagate to the children recursively the update action.
     * Default is true.
     * @param cascade
     * @return
     */
    SaveOrUpdate<BEAN> cascade(boolean cascade);

}
