package com.jpattern.orm.query.update;

import java.util.List;

import com.jpattern.orm.query.clause.OrmWhere;

/**
 * 
 * @author ufo
 *
 */
public class CustomUpdateWhereImpl extends OrmWhere<CustomUpdateWhere> implements CustomUpdateWhere {

    private final CustomUpdateQuery updateQuery;

    public CustomUpdateWhereImpl(final CustomUpdateQuery updateQuery) {
        this.updateQuery = updateQuery;

    }

    @Override
    public CustomUpdateQuery query() {
        return updateQuery;
    }

    @Override
    public CustomUpdateSet set() {
        return updateQuery.set();
    }

    @Override
    protected CustomUpdateWhere where() {
        return this;
    }

    @Override
    public int now() {
        return updateQuery.now();
    }

    @Override
    public final void appendValues(final List<Object> values) {
        updateQuery.appendValues(values);
    }

    @Override
    public String renderSql() {
        return updateQuery.renderSql();
    }

    @Override
    public void renderSql(final StringBuilder stringBuilder) {
        updateQuery.renderSql(stringBuilder);
    }

    @Override
    public CustomUpdateQuery queryTimeout(final int queryTimeout) {
        return updateQuery.queryTimeout(queryTimeout);
    }

}
