package com.jpattern.orm.query.update;

import java.util.Map;

import com.jpattern.orm.query.QueryRoot;


/**
 * 
 * @author Francesco Cina
 *
 * 10/lug/2011
 */
public interface UpdateQuery<BEAN> extends QueryRoot {

    /**
     * @return
     */
    UpdateQuery<BEAN> value(String propertyName, Object value);

    /**
     * Perform the update and return the number of affected rows.
     * @return
     */
    BEAN perform();

    /**
     * Set the query timeout for the query.
     */
    UpdateQuery<BEAN> setQueryTimeout(int queryTimeout);

    /**
     * Return the query timeout for the query.
     */
    int getQueryTimeout();

    /**
     * @param properties
     * @return
     */
    UpdateQuery<BEAN> values(Map<String, Object> properties);

    /**
     * Whether to update the children recursively. Default is false.
     * @param cascade
     * @return
     */
    UpdateQuery<BEAN> cascade(boolean cascade);

    /**
     * @param saveOrUpdate
     * @return
     */
    UpdateQuery<BEAN> saveOrUpdate(boolean saveOrUpdate);
}
