package com.jpattern.orm.validator.jsr303;

import javax.validation.Validation;
import javax.validation.ValidatorFactory;

import com.jpattern.orm.validator.ValidatorService;
import com.jpattern.orm.validator.Validator;

/**
 * 
 * @author ufo
 *
 */
public class JSR303ValidatorService implements ValidatorService {

    private final ValidatorFactory factory = Validation.buildDefaultValidatorFactory();

    @Override
    public <T> Validator<T> validator(final T data) {
        return new JSR303Validator<T>(data, this.factory.getValidator());
    }

}
