package com.jpattern.orm.validator.oval;

import java.util.List;

import net.sf.oval.ConstraintViolation;
import net.sf.oval.exception.ConstraintsViolatedException;

import com.jpattern.orm.validator.Validator;

/**
 * 
 * <class_description>
 * <p><b>notes</b>:
 * <p>ON : Feb 27, 2013
 *
 * @author Francesco Cina'
 * @version $Revision
 */
public class OvalValidator<T> implements Validator<T> {

    private final T data;
    private final net.sf.oval.Validator validator;

    public OvalValidator(final T data, final net.sf.oval.Validator validator) {
        this.data = data;
        this.validator = validator;
    }

    @Override
    public void validateThrowException() {
        List<ConstraintViolation> violations = this.validator.validate(this.data);
        if (!violations.isEmpty()) {
            throw new ConstraintsViolatedException(violations);
        }
    }

}
